/*
 * 
 *
 * Copyright (c) 2006 vixy project
 *
 * This file is part of VIXY FLV Converter.
 *
 * 'VIXY FLV Converter' is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * 'VIXY FLV Converter' is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FFmpeg; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef AVFORMAT_WRITER_H
#define AVFORMAT_WRITER_H

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include "type.h"
#include "avformat.h" // libavformat is part of ffmpeg(http://ffmpeg.sf.net)
#include "mp3header.h"

typedef struct _AVFWRITER
{
    AVOutputFormat* fmt;
    AVFormatContext* oc;
	AVStream *audio_st;
	AVStream *video_st;
	
	int write_header;
} AVFWRITER;


void avfwriter_global_init();
AVFWRITER* avfwriter_init(const char* fn);

int avfwriter_set_m4v_header(AVFWRITER* p, 
	int width, int height, int bitrate,
	const uint8* extradata, int extradatasize);

int avfwriter_set_mp3_header(AVFWRITER* p, MP3HEADER* mp3header);
int avfwriter_write_header(AVFWRITER* p);
int avfwriter_write_m4v_frame(AVFWRITER* p, int keyframe, int pts, const uint8* buf, int size);
int avfwriter_write_mp3_frame(AVFWRITER* p, int pts, const uint8* buf, int size);
int avfwriter_release(AVFWRITER* p);

const char* avfwriter_get_format_name(AVFWRITER* p);

#endif // AVFORMAT_WRITER_H
